{***********************************************************************
 * appl.pas - Zakladni schema aplikacniho programu pro WinBase602.      *
 *            MDI-klienta vytvar aplikace                             *
 * (C) Janus Drozd, Pavel Kubricht 1992, 93, 94, 95, 96, 97            *
 * Verze 5 ze dne 3.4.1997                                             *
 *                                                                     *
 * pozn.: Budete-li program kompilovat v Delphi, musi mit priponu .DPR,*
 * budete-li program kompilovat v Borland Pascalu, musi mit priponu    *
 * .PAS                                                                *
 ***********************************************************************}

{$X+,A-}
{$MINSTACKSIZE 20000}

program Appl1;   { Kostra aplikace - rozhrani urovne 1 }

uses WinTypes, WinProcs, Messages, WinBase;
//  {$I appl.sip}   - definicni soubor vytvoreny pro tuto aplikaci

const MOJE_APLIKACE = 'MojeAplikace';
var   logged_in, interf_is_init : Boolean;
      hMainWindow, hClient : HWnd;

function MainWindowProc(Window: HWnd;  Message, WParam: Integer;
                        LParam: Longint): Longint;   stdcall;  export;
begin
  MainWindowProc := 0;
  case Message of
    wm_Command:
      case WParam of
        IDM_HELP_GENERIC:
          begin
            WinHelp(Window, 'MYHELP.HLP', HELP_CONTEXT, LOWORD(LParam));
            Exit;
          end;

        91: {Kliknuli jsme na polozku Mozaika menu Winbase602: }
          begin
           SendMessage(hClient, WM_MDITILE, MDITILE_HORIZONTAL, 0);
           Exit;
          end;
        92: {Kliknuli jsme na polozku Kaskda menu Winbase602: }
          begin
           SendMessage(hClient, WM_MDICASCADE, 0, 0);
           Exit;
         end;
      1001: {Kliknuli jsme na polozku Konec - Vzorove aplikace dodvan s WinBase602
       pouzivane v tomto prikladu musite doplnit tak, aby polozka winbasovskeho menu
       ukoncujici aplikaci vyslala pri sve aktivaci zpravu 1001.}
         begin
          WinHelp(Window, 'MYHELP.HLP', HELP_QUIT, 0);
          if logged_in then begin Logout;logged_in := False; end;
          if interf_is_init then begin interf_close; interf_is_init := False; end;
         end;
      end;
    wm_Destroy:
      begin
        WinHelp(Window, 'MYHELP.HLP', HELP_QUIT, 0);
        if logged_in then Logout;
        if interf_is_init then interf_close;
        PostQuitMessage(0);
      end;
  end;
  if Message = wm_Create then  // WM_CREATE nesmi dostat WinBase602
    MainWindowProc := DefFrameProc(Window, hClient, message, WParam, LParam)
  else MainWindowProc := DefWinBaseFrameProc(Window, Message, WParam, LParam);
end;

function InitApplication : Boolean; { registrace tridy }
var WindowClass: TWndClass;
begin
    WindowClass.hInstance     := HInstance;
    WindowClass.hIcon         := LoadIcon(0, idi_Application);
    WindowClass.hCursor       := LoadCursor(0, idc_Arrow);
    WindowClass.hbrBackground := GetStockObject(white_Brush);
    WindowClass.lpfnWndProc   := @MainWindowProc;
    WindowClass.style         := 0;
    WindowClass.cbClsExtra    := 0;
    WindowClass.cbWndExtra    := 0;
    WindowClass.lpszMenuName  := nil;
    WindowClass.lpszClassName := MOJE_APLIKACE;
{$IFDEF WIN32}
    InitApplication := RegisterClass(WindowClass) <> 0;
{$ELSE}
    InitApplication := RegisterClass(WindowClass);
{$ENDIF}
end;

function InitInstance : hWnd;  { otevreni hlavniho okna }
begin
InitInstance := CreateWindow(MOJE_APLIKACE, 'Toto je ramec pro aplikace ve WinBase602',
       ws_OverlappedWindow,
        cw_UseDefault, cw_UseDefault, 640,480,
        0, 0, HInstance, nil);
end;

function InitClient: hWnd; { vytvoreni klientckeho okna }
var ClientCreateStruct: TClientCreateStruct;
begin
  with ClientCreateStruct do begin idFirstChild := $FF00; hWindowMenu := 0;  end;
  InitClient := CreateWindow('MDICLIENT', nil, WS_CHILD or WS_VISIBLE or WS_GROUP or
    WS_TABSTOP or  WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL or WS_CLIPSIBLINGS
    or MDIS_ALLCHILDSTYLES, 0, 0,640,480, hMainWindow, 0, HInstance, @ClientCreateStruct);
end;

procedure WinMain;
var Message: TMsg;
    my_cd : cd_t;
    Uspech: Boolean;
begin
  cdp_init(@my_cd);
  interf_is_init := FALSE;
  logged_in := FALSE;
  if HPrevInst = 0 then
    if not InitApplication then halt(1);
  hMainWindow := InitInstance;
  if hMainWindow = 0 then halt(2);
  hClient := InitClient;
  if hClient = 0 then halt(2);
  ShowWindow(hMainWindow, CmdShow);
  UpdateWindow(hMainWindow);

  Init_window_env(hMainWindow, hClient, -1, 0);
  Info_box('Vzorov aplikace WinBase602 v Pascalu - rozhran rovn 1',
     'MDI-klienta vytv aplikace');

  if link_kernel('WB5', SW_SHOWMINNOACTIVE) <> 0 then
    begin  DestroyWindow(hMainWindow);  halt(3)  end;
  if interf_init(@my_cd, 0) <> 0 then
    begin  DestroyWindow(hMainWindow);  halt(4)  end;
  interf_is_init := TRUE;
  BringWindowToTop(hMainWindow);
  if not Alogin(hMainWindow) then
    begin  DestroyWindow(hMainWindow);  halt(5)  end;
  logged_in := TRUE;
  Set_application('PER_AGENDA');
  Uspech := Open_project('MIN_PLAT');
  if (Uspech = False) then Info_box('Chyba','Nelze otevrit projekt');
  Main_menu('*AGENDA');

  while GetMessage(Message, 0, 0, 0) do
    if not TranslateMDISysAccel(hClient, Message) then
    begin
      TranslateMessage(Message);
      DispatchMessage(Message);
    end;
  Halt(Message.wParam);
end;

begin
  WinMain;
end.

